﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tutorium5
{
    class Program
    {
        static void Main(string[] args)
        {
            //Aufgabe 2
            Random generator = new Random();
            int[] zufallszahlen = new int[10];
            for (int i = 0; i < zufallszahlen.Length; i++) {
                //get new random number
                int zufallszahl = generator.Next(1, 101);
                zufallszahlen[i] = zufallszahl;
                Console.Write(zufallszahlen[i] + " ");
            }
            Console.WriteLine();

            //Summe
            Console.WriteLine("Summe: {0}", zufallszahlen.Sum());
            //Minimum
            Console.WriteLine("Minimum: {0}", zufallszahlen.Min());
			//Maximum
            Console.WriteLine("Maximum: {0}", zufallszahlen.Max());

            for (int i = 0; i < zufallszahlen.Length; i += 2) {
                Console.Write(zufallszahlen[i] + " ");
            }
            Console.ReadLine();



            //Aufgabe 3
            //Random
            generator = new Random();  //wurde oben schon deklariert, daher entfällt das hier
            List<int> zufallszahlenListe = new List<int>();
            for (int i = 0; i <= 10; i++) {
                //get new random number
                int zufallszahl = generator.Next(1, 101);
                zufallszahlenListe.Add(zufallszahl);
                Console.Write(zufallszahlenListe[i] + " ");
            }
            Console.WriteLine();

            //Summe
            Console.WriteLine("Summe: {0}", zufallszahlenListe.Sum());
            //Minimum
            Console.WriteLine("Minimum: {0}", zufallszahlenListe.Min());
            //Maximum
            Console.WriteLine("Maximum: {0}", zufallszahlenListe.Max());

			for (int i = 0; i < zufallszahlenListe.Count; i += 2) {
                Console.Write(zufallszahlenListe[i] + " ");
            }
            Console.ReadLine();



            //Aufgabe 4
            //Warteschlange erstellen
            Queue<string> warteschlange = new Queue<string>();

            Console.WriteLine("Elemente zum Anhängen eingeben!");
			Console.WriteLine("Zum Beenden 'exit' eingeben!");
			Console.WriteLine("Drücken von Enter (leere Eingabe führt zu Entnahme eines Elements aus der Warteschlange!");
            while (true) {
                //Eingabe
                string eingabe = Console.ReadLine();

                if (eingabe == "") { //leere Eingabe
                    //ein Element wird vorne entnommen
                    string erstesElement = warteschlange.Dequeue();
                    Console.WriteLine("Entnommenes Element: {0}", erstesElement);
                    Console.Write("Verbliebene Elemente:");
                    foreach (string element in warteschlange)
                        Console.Write(element + " ");
                    Console.WriteLine();

                } else if (eingabe == "exit") {
                    //Abbruch, damit das Programm beendet werden kann (ist nicht gefordert, aber ganz praktisch, damit man das Programm beenden kann...)
                    Console.WriteLine("Programm wird beendet!");
                    break;
                } else {
                    //jede andere Eingabe wird als Element an die Warteschlange angehängt
                    warteschlange.Enqueue(eingabe);
                    Console.WriteLine("{0} wurde an die Warteschlange angefügt", eingabe);
                    Console.Write("Vorhandene Elemente:");
                    foreach (string element in warteschlange)
                        Console.Write(element + " ");
                    Console.WriteLine();
                }
            }
            Console.ReadLine();
            

            //Aufgabe 5
            //Stapel erstellen
            Stack<string> stapel = new Stack<string>();

            int z = 0; //Zähler, der genutzt wird um die Teller unterscheiden zu können

            Console.WriteLine("'push' oder 'pop' eingeben!");

            while (true) {
                //Eingabe
                string eingabe = Console.ReadLine();

                if (eingabe == "pop") { //Element entfernen
                    //ein Element wird von oben entnommen
                    string erstesElement = stapel.Pop();
                    Console.WriteLine("Entnommenes Element: {0}", erstesElement);
                    Console.Write("Verbliebene Elemente:");
                    foreach (string element in stapel)
                        Console.Write(element + " ");
                    Console.WriteLine();

                } else if (eingabe == "push") {
                    stapel.Push("Teller" + z);
                    z++; //Zähler hochsetzen
                    foreach (string element in stapel)
                        Console.Write(element + " ");
                    Console.WriteLine();
                } else {
                    //jede andere Eingabe beendet das Program
                    Console.WriteLine("Programm wird beendet!");
                    break;

                }
            }
	    Console.ReadLine();

        }
    }
}
